#include <iostream>
#include <cmath>
using namespace std;
int main(int argc, char** argv) {
	
/*
3
2 1
1 2
3 3

0
1
4

4
1 2
2 1
5 4
3 5

0
1
17
24
*/
	
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int m;
	cin>>m;
	int dx=0,dy=0,tackax[m+5],tackay[m+5];
	bool x[100000],y[100000];
	for (int i=0;i<10000;i++){
		x[i]=false;
		y[i]=false;
	}
	cin>>tackax[0]>>tackay[0];
	dx=tackax[0];
	dy=tackay[0];
	cout<<"0\n";
	for (int i=1;i<m;i++){ 
		int rez=0;
		cin>>tackax[i]>>tackay[i];
		x[tackax[i]]=true;
		y[tackay[i]]=true;
		int tr;
		if (tackax[i]>dx) dx=tackax[i];
		if (tackay[i]>dy) dy=tackay[i];
		for (int j=0;j<=dx;j++){
			tr=0;
			for (int idot=0;idot<=dy;idot++){
				tr=0;
				for (int k=0;k<i;k++){
	//				cout<<"k "<<k<<endl;
					if ((x[j]==true) and (y[idot]==true)){
						tr+=abs(tackax[k]-j)*abs(tackay[k]-idot);
	//					cout<<"tr: "<<tr<<endl;
					}
				}
				if (tr>rez){
					rez=tr;
				}
	//			cout<<i<<" "<<idot<<" k"<<endl;
			}
		}
	//	cout<<endl<<"rez "<<i<<"    "<<rez<<endl<<endl;
		cout<<rez<<endl;
	}
	
	return 0;
}